commit 5f4a60c43d5cd805add6529b4528c35893c283ae
Author: Georg-Johann Lay <avr@gjlay.de>
Date:   Fri Jul 5 13:22:12 2024 +0200

    AVR: target/87376 - Use nop_general_operand for DImode inputs.
    
    The avr-dimode.md expanders have code like  emit_move_insn(acc_a, operands[1])
    where acc_a is a hard register and operands[1] might be a non-generic
    address-space memory reference.  Such loads may clobber hard regs since
    some of them are implemented as libgcc calls /and/ 64-moves are
    expanded as eight byte-moves, so that acc_a or acc_b might be clobbered
    by such a load.
    
    This patch simply denies non-generic address-space references by using
    nop_general_operand for all avr-dimode.md input predicates.
    With the patch, all memory loads that require library calls are issued
    before the expander codes from avr-dimode.md are run.
    
            PR target/87376
    gcc/
            * config/avr/avr-dimode.md: Use "nop_general_operand" instead
            of "general_operand" as predicate for all input operands.
    
    gcc/testsuite/
            * gcc.target/avr/torture/pr87376.c: New test.
    
    (cherry picked from commit 23a0935262d6817097406578b1c70563f424804b)

diff --git a/gcc/testsuite/gcc.target/avr/torture/pr87376.c b/gcc/testsuite/gcc.target/avr/torture/pr87376.c
new file mode 100644
index 00000000000..c31a4a9dda5
--- /dev/null
+++ b/gcc/testsuite/gcc.target/avr/torture/pr87376.c
@@ -0,0 +1,60 @@
+/* { dg-do run { target { ! avr_tiny } } } */
+/* { dg-additional-options "-std=gnu99" } */
+
+typedef __UINT64_TYPE__ uint64_t;
+
+extern const __memx uint64_t aa __asm ("real_aa");
+extern const uint64_t bb __asm ("real_bb");
+
+const __memx uint64_t real_aa = 0x1122334455667788;
+const uint64_t real_bb        = 0x0908070605040302;
+
+__attribute__((noinline,noclone))
+uint64_t add1 (void)
+{
+  return aa + bb;
+}
+
+__attribute__((noinline,noclone))
+uint64_t add2 (void)
+{
+  return bb + aa;
+}
+
+__attribute__((noinline,noclone))
+uint64_t sub1 (void)
+{
+  return aa - bb;
+}
+
+__attribute__((noinline,noclone))
+uint64_t sub2 (void)
+{
+  return bb - aa;
+}
+
+__attribute__((noinline,noclone))
+uint64_t neg1 (void)
+{
+  return -aa;
+}
+
+int main (void)
+{
+  if (neg1() != -real_aa)
+  __builtin_exit (__LINE__);
+
+  if (add1() != real_aa + real_bb)
+    __builtin_exit (__LINE__);
+
+  if (add2() != real_bb + real_aa)
+    __builtin_exit (__LINE__);
+
+  if (sub1() != real_aa - real_bb)
+    __builtin_exit (__LINE__);
+  
+  if (sub2() != real_bb - real_aa)
+    __builtin_exit (__LINE__);
+
+  return 0;
+}

